"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var os_1 = require("os");
var config_1 = require("../config");
exports.buildLaunchOptions = function (device) {
    var launchOptions = {
        args: [
            "--no-default-browser-check",
            "--window-size=" + device.viewport.width + "," + device.viewport.height
        ],
        defaultViewport: null,
        headless: config_1.CONFIG.headless,
        ignoreDefaultArgs: ["--enable-automation"]
    };
    if (os_1.platform() === "linux") {
        launchOptions.args.push("--disable-setuid-sandbox");
        launchOptions.args.push("--no-sandbox");
    }
    if (config_1.CONFIG.chromeExecutablePath) {
        launchOptions.executablePath = config_1.CONFIG.chromeExecutablePath;
    }
    return launchOptions;
};
//# sourceMappingURL=buildLaunchOptions.js.map