"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_extra_1 = require("fs-extra");
var path_1 = require("path");
var config_1 = require("../config");
var timer_1 = require("../timer");
exports.screenshot = function (browser) { return __awaiter(void 0, void 0, void 0, function () {
    var path, page;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!config_1.CONFIG.screenshotPath)
                    return [2];
                return [4, timer_1.sleep(1000)];
            case 1:
                _a.sent();
                path = path_1.resolve(config_1.CONFIG.screenshotPath);
                return [4, fs_extra_1.ensureDir(path)];
            case 2:
                _a.sent();
                return [4, browser.currentPage()];
            case 3:
                page = _a.sent();
                return [4, page.screenshot({ path: path + "/" + Date.now() + ".png" })];
            case 4:
                _a.sent();
                return [2];
        }
    });
}); };
exports.beforeAll = function (browser) { return __awaiter(void 0, void 0, void 0, function () {
    var wsEndpoint;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!config_1.CONFIG.saveBrowserWsPath) return [3, 2];
                wsEndpoint = browser._browser.wsEndpoint();
                return [4, fs_extra_1.writeJSON(config_1.CONFIG.saveBrowserWsPath, { wsEndpoint: wsEndpoint })];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2];
        }
    });
}); };
exports.beforeEach = function (browser) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, exports.screenshot(browser)];
            case 1:
                _a.sent();
                return [2];
        }
    });
}); };
exports.afterEach = function (browser) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!config_1.CONFIG.sleepAfterEach) return [3, 2];
                return [4, timer_1.sleep(config_1.CONFIG.sleepAfterEach)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2];
        }
    });
}); };
exports.afterAll = function (browser) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!!config_1.CONFIG.keepBrowserOpen) return [3, 2];
                return [4, browser.close()];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2];
        }
    });
}); };
//# sourceMappingURL=hooks.js.map