"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Browser_1 = require("./Browser");
var config_1 = require("../config");
var runStep_1 = require("./runStep");
var pageUtils_1 = require("./pageUtils");
describe("runStep", function () {
    test("clicks on link", function () { return __awaiter(void 0, void 0, void 0, function () {
        var browser, page;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Browser_1.Browser.create({ url: config_1.CONFIG.testUrl })];
                case 1:
                    browser = _a.sent();
                    return [4, browser.currentPage()];
                case 2:
                    page = _a.sent();
                    return [4, runStep_1.runStep(page, {
                            action: "click",
                            target: { xpath: '//*[@id="content"]/ul/li[3]/a' }
                        })];
                case 3:
                    _a.sent();
                    return [4, page.waitForNavigation()];
                case 4:
                    _a.sent();
                    expect(page.url()).toBe(config_1.CONFIG.testUrl + "broken_images");
                    return [4, browser.close()];
                case 5:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test("clicks on icon in button", function () { return __awaiter(void 0, void 0, void 0, function () {
        var browser, page, messageText, messageText2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Browser_1.Browser.create({ url: config_1.CONFIG.testUrl + "login" })];
                case 1:
                    browser = _a.sent();
                    return [4, browser.currentPage()];
                case 2:
                    page = _a.sent();
                    return [4, pageUtils_1.$xText(page, '//*[@id="flash-messages"]')];
                case 3:
                    messageText = _a.sent();
                    expect(messageText).not.toContain("username is invalid");
                    return [4, runStep_1.runStep(page, {
                            action: "click",
                            target: { tagName: "i", xpath: "//*[@id='login']/button/i" }
                        })];
                case 4:
                    _a.sent();
                    return [4, pageUtils_1.$xText(page, '//*[@id="flash"]')];
                case 5:
                    messageText2 = _a.sent();
                    expect(messageText2).toContain("username is invalid");
                    return [4, browser.close()];
                case 6:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test("scrolls to given position", function () { return __awaiter(void 0, void 0, void 0, function () {
        var browser, page, initialYPosition, nextYPosition, finalYPosition;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Browser_1.Browser.create({ url: config_1.CONFIG.testUrl + "large" })];
                case 1:
                    browser = _a.sent();
                    return [4, browser.currentPage()];
                case 2:
                    page = _a.sent();
                    return [4, page.evaluate(function () { return window.pageYOffset; })];
                case 3:
                    initialYPosition = _a.sent();
                    expect(initialYPosition).toBe(0);
                    return [4, browser.runStep({
                            action: "scroll",
                            target: { xpath: "scroll" },
                            scrollTo: 1000
                        })];
                case 4:
                    _a.sent();
                    return [4, page.evaluate(function () { return window.pageYOffset; })];
                case 5:
                    nextYPosition = _a.sent();
                    expect(nextYPosition).toBe(1000);
                    return [4, browser.runStep({
                            action: "scroll",
                            target: { xpath: "scroll" },
                            scrollTo: 0
                        })];
                case 6:
                    _a.sent();
                    return [4, page.evaluate(function () { return window.pageYOffset; })];
                case 7:
                    finalYPosition = _a.sent();
                    expect(finalYPosition).toBe(0);
                    return [4, browser.close()];
                case 8:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test("scrolls in infinite scroll", function () { return __awaiter(void 0, void 0, void 0, function () {
        var browser, page, initialYPosition, nextYPosition;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Browser_1.Browser.create({
                        url: config_1.CONFIG.testUrl + "infinite_scroll"
                    })];
                case 1:
                    browser = _a.sent();
                    return [4, browser.currentPage()];
                case 2:
                    page = _a.sent();
                    return [4, page.evaluate(function () { return window.pageYOffset; })];
                case 3:
                    initialYPosition = _a.sent();
                    expect(initialYPosition).toBe(0);
                    return [4, browser.runStep({
                            action: "scroll",
                            target: { xpath: "scroll" },
                            scrollTo: 2000
                        })];
                case 4:
                    _a.sent();
                    return [4, page.evaluate(function () { return window.pageYOffset; })];
                case 5:
                    nextYPosition = _a.sent();
                    expect(nextYPosition).toBe(2000);
                    return [4, browser.close()];
                case 6:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test("sets input value", function () { return __awaiter(void 0, void 0, void 0, function () {
        var browser, page, _a, username, password, _b, username2, password2, _c, username3, password3;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4, Browser_1.Browser.create({
                        url: config_1.CONFIG.testUrl + "login"
                    })];
                case 1:
                    browser = _d.sent();
                    return [4, browser.currentPage()];
                case 2:
                    page = _d.sent();
                    return [4, page.$$eval("input", function (inputs) { return inputs.map(function (i) { return i.value; }); })];
                case 3:
                    _a = _d.sent(), username = _a[0], password = _a[1];
                    expect(username).toBeFalsy();
                    expect(password).toBeFalsy();
                    return [4, browser.runStep({
                            action: "input",
                            target: { xpath: '//*[@id="username"]' },
                            value: "spirit"
                        })];
                case 4:
                    _d.sent();
                    return [4, page.$$eval("input", function (inputs) { return inputs.map(function (i) { return i.value; }); })];
                case 5:
                    _b = _d.sent(), username2 = _b[0], password2 = _b[1];
                    expect(username2).toBe("spirit");
                    expect(password2).toBeFalsy();
                    return [4, browser.runStep({
                            action: "input",
                            target: { xpath: '//*[@id="password"]' },
                            value: "password"
                        })];
                case 6:
                    _d.sent();
                    return [4, page.$$eval("input", function (inputs) { return inputs.map(function (i) { return i.value; }); })];
                case 7:
                    _c = _d.sent(), username3 = _c[0], password3 = _c[1];
                    expect(username3).toBe("spirit");
                    expect(password3).toBe("password");
                    return [4, browser.close()];
                case 8:
                    _d.sent();
                    return [2];
            }
        });
    }); });
    test("selects option in select", function () { return __awaiter(void 0, void 0, void 0, function () {
        var browser, page, selectValue, selectValue2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Browser_1.Browser.create({
                        url: config_1.CONFIG.testUrl + "dropdown"
                    })];
                case 1:
                    browser = _a.sent();
                    return [4, browser.currentPage()];
                case 2:
                    page = _a.sent();
                    return [4, page.evaluate(function () {
                            var select = document.getElementsByTagName("select")[0];
                            return select.value;
                        })];
                case 3:
                    selectValue = _a.sent();
                    expect(selectValue).toBeFalsy();
                    return [4, browser.runStep({
                            action: "input",
                            target: { id: "dropdown", tagName: "select" },
                            value: "2"
                        })];
                case 4:
                    _a.sent();
                    return [4, page.evaluate(function () {
                            var select = document.getElementsByTagName("select")[0];
                            return select.value;
                        })];
                case 5:
                    selectValue2 = _a.sent();
                    expect(selectValue2).toBe("2");
                    return [4, browser.close()];
                case 6:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
//# sourceMappingURL=runStep.test.js.map