"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var buildSteps_1 = require("./buildSteps");
exports.findUrl = function (events) {
    for (var _i = 0, events_1 = events; _i < events_1.length; _i++) {
        var e = events_1[_i];
        if (e.data && e.data.href)
            return e.data.href;
    }
    throw new Error("No url found");
};
exports.findSize = function (events) {
    return events.filter(function (e) { return e.type === "size"; })[0].size;
};
exports.orderEventsByTime = function (events) {
    var orderedEvents = [];
    for (var _i = 0, events_2 = events; _i < events_2.length; _i++) {
        var originalEvent = events_2[_i];
        var event_1 = JSON.parse(JSON.stringify(originalEvent));
        var positions = (event_1.data && event_1.data.positions) || [];
        if (positions.length) {
            var firstOffset = positions[0].timeOffset;
            event_1.timestamp += firstOffset;
            for (var _a = 0, positions_1 = positions; _a < positions_1.length; _a++) {
                var position = positions_1[_a];
                position.timeOffset -= firstOffset;
            }
        }
        orderedEvents.push(event_1);
    }
    orderedEvents.sort(function (a, b) { return a.timestamp - b.timestamp; });
    return orderedEvents;
};
exports.buildJob = function (originalEvents, name) {
    var url = exports.findUrl(originalEvents);
    var size = exports.findSize(originalEvents);
    var events = exports.orderEventsByTime(originalEvents);
    var steps = buildSteps_1.buildSteps(events);
    var job = { name: name, size: size, steps: steps, url: url };
    return job;
};
//# sourceMappingURL=buildJob.js.map