"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fixtures_1 = require("@qawolf/fixtures");
var buildSteps_1 = require("./buildSteps");
var loginJob_1 = require("../fixtures/loginJob");
describe("buildClickSteps", function () {
    test("returns steps for all clicks if no next sequence", function () {
        var eventSequence = {
            action: "click",
            events: [
                {
                    data: {
                        properties: {
                            id: "button"
                        }
                    },
                    pageId: 0
                },
                {
                    data: {
                        properties: {
                            id: "button"
                        }
                    },
                    pageId: 0
                }
            ],
            xpath: "button"
        };
        expect(buildSteps_1.buildClickSteps(eventSequence, null)).toMatchObject([
            {
                action: "click",
                target: { id: "button" },
                pageId: 0
            },
            {
                action: "click",
                target: { id: "button" },
                pageId: 0
            }
        ]);
    });
    test("returns steps for all clicks if next group not typing", function () {
        var eventSequence = {
            action: "click",
            events: [
                {
                    data: {
                        properties: {
                            id: "button"
                        }
                    },
                    pageId: 0
                },
                {
                    data: {
                        properties: {
                            id: "button"
                        }
                    },
                    pageId: 0
                }
            ],
            xpath: "button"
        };
        var nextGroup = {
            action: "scroll",
            events: [
                {
                    data: { y: 100 },
                    pageId: 0
                }
            ],
            xpath: "button"
        };
        expect(buildSteps_1.buildClickSteps(eventSequence, nextGroup)).toMatchObject([
            { action: "click", target: { id: "button" }, pageId: 0 },
            { action: "click", target: { id: "button" }, pageId: 0 }
        ]);
    });
    test("returns steps for all clicks if next group is different element", function () {
        var eventSequence = {
            action: "click",
            events: [
                {
                    data: {
                        properties: {
                            id: "button"
                        }
                    },
                    pageId: 0
                },
                {
                    data: {
                        properties: {
                            id: "button"
                        }
                    },
                    pageId: 0
                }
            ],
            xpath: "button"
        };
        var nextGroup = {
            action: "click",
            events: [
                {
                    data: {
                        properties: {
                            id: "anotherButton"
                        }
                    },
                    pageId: 0
                }
            ],
            xpath: "anotherButton"
        };
        expect(buildSteps_1.buildClickSteps(eventSequence, nextGroup)).toMatchObject([
            {
                target: { id: "button" },
                pageId: 0,
                action: "click"
            },
            {
                target: { id: "button" },
                pageId: 0,
                action: "click"
            }
        ]);
    });
    test("does not include last click if next group is typing into same element", function () {
        var eventSequence = {
            action: "click",
            events: [
                {
                    data: {
                        properties: {
                            id: "input"
                        }
                    },
                    pageId: 0
                },
                {
                    data: {
                        properties: {
                            id: "input"
                        }
                    },
                    pageId: 0
                }
            ],
            xpath: "input"
        };
        var nextGroup = {
            action: "input",
            events: [
                {
                    data: {
                        properties: {
                            id: "button"
                        },
                        text: "spirit"
                    },
                    pageId: 0
                }
            ],
            xpath: "input"
        };
        expect(buildSteps_1.buildClickSteps(eventSequence, nextGroup)).toMatchObject([
            {
                action: "click",
                target: { id: "input" },
                pageId: 0
            }
        ]);
    });
});
describe("buildInputStep", function () {
    test("returns built input step", function () {
        var eventSequence = {
            action: "input",
            events: [
                {
                    data: {
                        properties: {
                            id: "username"
                        },
                        text: "s"
                    },
                    pageId: 0
                },
                {
                    data: {
                        properties: {
                            id: "username"
                        },
                        text: "sp"
                    },
                    pageId: 0
                }
            ],
            xpath: "username"
        };
        expect(buildSteps_1.buildInputStep(eventSequence)).toMatchObject({
            action: "input",
            target: {
                id: "username"
            },
            pageId: 0,
            value: "sp"
        });
    });
});
describe("buildScrollStep", function () {
    test("returns null if not enough actions", function () {
        var eventSequence = {
            action: "scroll",
            events: [
                {
                    data: { y: 0 }
                }
            ],
            xpath: null
        };
        expect(buildSteps_1.buildScrollStep(eventSequence)).toBeNull();
    });
    test("returns last scroll step if scrolling down", function () {
        var eventSequence = {
            action: "scroll",
            events: [
                {
                    data: { y: 0 },
                    pageId: 0
                },
                {
                    data: { y: 150 },
                    pageId: 0
                },
                {
                    data: { y: 100 },
                    pageId: 0
                }
            ],
            xpath: null
        };
        expect(buildSteps_1.buildScrollStep(eventSequence)).toMatchObject({
            action: "scroll",
            target: { xpath: "scroll" },
            pageId: 0,
            scrollDirection: "down",
            scrollTo: 100
        });
    });
    test("returns last scroll step if scrolling up", function () {
        var eventSequence = {
            action: "scroll",
            events: [
                {
                    data: { y: 100 },
                    pageId: 0
                },
                {
                    data: { y: 150 },
                    pageId: 0
                },
                {
                    data: { y: 0 },
                    pageId: 0
                }
            ],
            xpath: null
        };
        expect(buildSteps_1.buildScrollStep(eventSequence)).toMatchObject({
            action: "scroll",
            target: { xpath: "scroll" },
            pageId: 0,
            scrollDirection: "up",
            scrollTo: 0
        });
    });
});
describe("buildSequenceSteps", function () {
    test("returns correct steps for action groups", function () { return __awaiter(void 0, void 0, void 0, function () {
        var events, actionEvents, eventSequences, steps;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, fixtures_1.loadEvents("login")];
                case 1:
                    events = _a.sent();
                    actionEvents = buildSteps_1.findActionEvents(events);
                    eventSequences = buildSteps_1.groupEventSequences(actionEvents);
                    steps = buildSteps_1.buildSequenceSteps(eventSequences);
                    expect(steps).toMatchObject(loginJob_1.loginSteps);
                    return [2];
            }
        });
    }); });
});
describe("findActionEvents", function () {
    test("returns only click, scroll, and input events", function () { return __awaiter(void 0, void 0, void 0, function () {
        var events, filteredEvents;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, fixtures_1.loadEvents("login")];
                case 1:
                    events = _a.sent();
                    expect(events).toHaveLength(135);
                    filteredEvents = buildSteps_1.findActionEvents(events);
                    expect(filteredEvents).toHaveLength(83);
                    return [2];
            }
        });
    }); });
});
describe("getEventAction", function () {
    test("returns click if click action", function () {
        var action = {
            data: {
                isTrusted: true,
                source: 2,
                type: 2
            }
        };
        expect(buildSteps_1.getEventAction(action)).toBe("click");
    });
    test("returns scroll if scroll action", function () {
        var action = {
            data: { source: 3, id: 1 }
        };
        expect(buildSteps_1.getEventAction(action)).toBe("scroll");
    });
    test("returns input if input action", function () {
        var action = {
            data: { source: 5, isTrusted: true, text: "spirit" }
        };
        expect(buildSteps_1.getEventAction(action)).toBe("input");
    });
    test("throws error if action type not found", function () {
        expect(function () {
            buildSteps_1.getEventAction({ data: { source: 11 } });
        }).toThrowError();
    });
});
describe("groupEventSequences", function () {
    test("returns actions grouped by element and type", function () { return __awaiter(void 0, void 0, void 0, function () {
        var events, actions, eventSequences;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, fixtures_1.loadEvents("login")];
                case 1:
                    events = _a.sent();
                    actions = buildSteps_1.findActionEvents(events);
                    eventSequences = buildSteps_1.groupEventSequences(actions);
                    expect(eventSequences).toHaveLength(10);
                    expect(eventSequences[0].action).toBe("scroll");
                    expect(eventSequences[0].events).toHaveLength(41);
                    expect(eventSequences[1]).toMatchObject({
                        action: "click",
                        xpath: "//*[@id='content']/ul/li[18]/a"
                    });
                    expect(eventSequences[1].events).toHaveLength(1);
                    expect(eventSequences[2]).toMatchObject({
                        action: "click",
                        xpath: "//*[@id='username']"
                    });
                    expect(eventSequences[2].events).toHaveLength(1);
                    expect(eventSequences[3]).toMatchObject({
                        action: "input",
                        xpath: "//*[@id='username']"
                    });
                    expect(eventSequences[3].events).toHaveLength(8);
                    expect(eventSequences[4]).toMatchObject({
                        action: "click",
                        xpath: "//*[@id='login']/button"
                    });
                    expect(eventSequences[4].events).toHaveLength(1);
                    expect(eventSequences[5]).toMatchObject({
                        action: "click",
                        xpath: "//*[@id='username']"
                    });
                    expect(eventSequences[5].events).toHaveLength(1);
                    expect(eventSequences[6]).toMatchObject({
                        action: "input",
                        xpath: "//*[@id='username']"
                    });
                    expect(eventSequences[6].events).toHaveLength(8);
                    expect(eventSequences[7]).toMatchObject({
                        action: "click",
                        xpath: "//*[@id='password']"
                    });
                    expect(eventSequences[7].events).toHaveLength(1);
                    expect(eventSequences[8]).toMatchObject({
                        action: "input",
                        xpath: "//*[@id='password']"
                    });
                    expect(eventSequences[8].events).toHaveLength(20);
                    expect(eventSequences[9]).toMatchObject({
                        action: "click",
                        xpath: "//*[@id='login']/button/i"
                    });
                    expect(eventSequences[9].events).toHaveLength(1);
                    return [2];
            }
        });
    }); });
});
describe("isInputEvent", function () {
    test("returns false if event undefined", function () {
        expect(buildSteps_1.isInputEvent()).toBe(false);
    });
    test("returns false if no data", function () {
        var event = {};
        expect(buildSteps_1.isInputEvent(event)).toBe(false);
    });
    test("returns false if data source not input", function () {
        var event = {
            data: { source: 2 }
        };
        expect(buildSteps_1.isInputEvent(event)).toBe(false);
    });
    test("returns false if data not trusted", function () {
        var event = {
            data: { source: 5, isTrusted: false }
        };
        expect(buildSteps_1.isInputEvent(event)).toBe(false);
    });
    test("returns false if no text", function () {
        var event = {
            data: { source: 5, isTrusted: true }
        };
        expect(buildSteps_1.isInputEvent(event)).toBe(false);
    });
    test("returns true if input event", function () {
        var event = {
            data: { source: 5, isTrusted: true, text: "spirit" }
        };
        expect(buildSteps_1.isInputEvent(event)).toBe(true);
    });
    test("returns true if input event with empty string", function () {
        var event = {
            data: { source: 5, isTrusted: true, text: "" }
        };
        expect(buildSteps_1.isInputEvent(event)).toBe(true);
    });
});
describe("isMouseDownEvent", function () {
    test("returns false if event undefined", function () {
        expect(buildSteps_1.isClickEvent()).toBe(false);
    });
    test("returns false if no data", function () {
        var event = {};
        expect(buildSteps_1.isClickEvent(event)).toBe(false);
    });
    test("returns false if data source not mouse interaction", function () {
        var event = {
            data: {
                source: 1
            }
        };
        expect(buildSteps_1.isClickEvent(event)).toBe(false);
    });
    test("returns false if data type not click", function () {
        var event = {
            data: {
                source: 2,
                type: 3
            }
        };
        expect(buildSteps_1.isClickEvent(event)).toBe(false);
    });
    test("returns false if data not trusted", function () {
        var event = {
            data: {
                isTrusted: false,
                source: 2,
                type: 2
            }
        };
        expect(buildSteps_1.isClickEvent(event)).toBe(false);
    });
    test("returns true if click event", function () {
        var event = {
            data: {
                isTrusted: true,
                source: 2,
                type: 2
            }
        };
        expect(buildSteps_1.isClickEvent(event)).toBe(true);
    });
});
describe("isScrollEvent", function () {
    test("returns false if event undefined", function () {
        expect(buildSteps_1.isScrollEvent()).toBe(false);
    });
    test("returns false if no data", function () {
        var event = {};
        expect(buildSteps_1.isScrollEvent(event)).toBe(false);
    });
    test("returns false if data source not scroll", function () {
        var event = {
            data: { source: 2 }
        };
        expect(buildSteps_1.isScrollEvent(event)).toBe(false);
    });
    test("returns false if scroll not on page body", function () {
        var event = {
            data: { source: 3, id: 11 }
        };
        expect(buildSteps_1.isScrollEvent(event)).toBe(false);
    });
    test("returns true if scroll on page body event", function () {
        var event = {
            data: { source: 3, id: 1 }
        };
        expect(buildSteps_1.isScrollEvent(event)).toBe(true);
    });
});
describe("buildSteps", function () {
    test("returns steps from events", function () { return __awaiter(void 0, void 0, void 0, function () {
        var events, steps;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, fixtures_1.loadEvents("login")];
                case 1:
                    events = _a.sent();
                    steps = buildSteps_1.buildSteps(events);
                    expect(steps).toMatchObject(loginJob_1.loginSteps);
                    return [2];
            }
        });
    }); });
});
//# sourceMappingURL=buildSteps.test.js.map