"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var dotenv_1 = __importDefault(require("dotenv"));
var dotEnvPath = process.env.DOTENV_PATH;
dotenv_1.default.config(dotEnvPath ? { path: dotEnvPath } : {});
var testUrl = process.env.TEST_URL || "";
var parseBool = function (value) {
    return !!value && value !== "false";
};
var parseNumber = function (value) {
    if (typeof value === "undefined")
        return value;
    return parseFloat(value);
};
exports.CONFIG = {
    chromeExecutablePath: process.env.CHROME_EXECUTABLE_PATH,
    dataAttribute: process.env.DATA_ATTRIBUTE || null,
    headless: parseBool(process.env.HEADLESS),
    keepBrowserOpen: parseBool(process.env.KEEP_BROWSER_OPEN),
    logPath: process.env.LOG_PATH,
    saveBrowserWsPath: process.env.SAVE_BROWSER_WS_PATH,
    screenshotPath: process.env.SCREENSHOT_PATH,
    sleepAfterEach: parseNumber(process.env.SLEEP_AFTER_EACH),
    testUrl: testUrl,
    useLocalModule: parseBool(process.env.USE_LOCAL_MODULE)
};
//# sourceMappingURL=config.js.map