"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Browser_1 = require("../browser/Browser");
var config_1 = require("../config");
var step = {
    locator: {
        xpath: "xpath"
    },
    type: "click"
};
var base = {
    classList: ["spirit", "bobcat", "moose"],
    href: null,
    id: "spirit",
    inputType: "submit",
    labels: null,
    name: null,
    parentText: ["some text", "even more text"],
    placeholder: null,
    tagName: "input",
    textContent: "click me!"
};
var browser;
beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, Browser_1.Browser.create()];
            case 1:
                browser = _a.sent();
                return [2];
        }
    });
}); });
afterAll(function () { return browser.close(); });
describe("rank.computeScoresForElements", function () {
    test("returns scores for each element", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, stepWithLocator, scores;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    stepWithLocator = __assign(__assign({}, step), { locator: __assign(__assign({}, base), { tagName: "input" }) });
                    return [4, page.evaluate(function (step) {
                            var qawolf = window.qawolf;
                            var collection = document.getElementsByTagName("input");
                            var elements = [];
                            for (var i = 0; i < collection.length; i++) {
                                elements.push(collection[i]);
                            }
                            return qawolf.rank.computeSimilarityScores(step, elements, null);
                        }, stepWithLocator)];
                case 2:
                    scores = _a.sent();
                    expect(scores).toEqual([100, 100]);
                    return [2];
            }
        });
    }); });
});
describe("rank.findCandidateElements", function () {
    test("returns all elements for click step", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, numElements;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    return [4, page.evaluate(function (step) {
                            var qawolf = window.qawolf;
                            return qawolf.rank.findCandidateElements(step).length;
                        }, step)];
                case 2:
                    numElements = _a.sent();
                    expect(numElements).toBe(28);
                    return [2];
            }
        });
    }); });
    test('returns inputs for "type" step', function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, typeAction, numElements;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    typeAction = __assign(__assign({ action: "input" }, step), { value: "spirit" });
                    return [4, page.evaluate(function (step) {
                            var qawolf = window.qawolf;
                            return qawolf.rank.findCandidateElements(step).length;
                        }, typeAction)];
                case 2:
                    numElements = _a.sent();
                    expect(numElements).toBe(2);
                    return [2];
            }
        });
    }); });
    test('returns select for "type" step', function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, typeAction, numElements;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "/dropdown")];
                case 1:
                    page = _a.sent();
                    typeAction = __assign(__assign({ action: "input" }, step), { value: "spirit" });
                    return [4, page.evaluate(function (step) {
                            var qawolf = window.qawolf;
                            return qawolf.rank.findCandidateElements(step).length;
                        }, typeAction)];
                case 2:
                    numElements = _a.sent();
                    expect(numElements).toBe(1);
                    return [2];
            }
        });
    }); });
});
describe("rank.findElementByDataValue", function () {
    test("returns null if no elements found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, element;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    return [4, page.evaluate(function () {
                            var qawolf = window.qawolf;
                            var element = qawolf.rank.findElementByDataValue("data-qa", "user");
                            return element;
                        })];
                case 2:
                    element = _a.sent();
                    expect(element).toBeNull();
                    return [2];
            }
        });
    }); });
    test("returns element if one found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, elementId;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    return [4, page.evaluate(function () {
                            var qawolf = window.qawolf;
                            var username = document.getElementById("username");
                            username.setAttribute("data-qa", "user");
                            var element = qawolf.rank.findElementByDataValue("data-qa", "user");
                            return element.id;
                        })];
                case 2:
                    elementId = _a.sent();
                    expect(elementId).toBe("username");
                    return [2];
            }
        });
    }); });
    test("throws error if multiple elements with same data value found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, throws;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    throws = function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2, page.evaluate(function () {
                                    var qawolf = window.qawolf;
                                    var username = document.getElementById("username");
                                    username.setAttribute("data-qa", "user");
                                    var password = document.getElementById("password");
                                    password.setAttribute("data-qa", "user");
                                    return qawolf.rank.findElementByDataValue("data-qa", "user");
                                })];
                        });
                    }); };
                    return [4, expect(throws()).rejects.toThrowError()];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
describe("rank.findTopElement", function () {
    test("returns null if no elements similar enough", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, stepWithLocator, highestMatch;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    stepWithLocator = __assign(__assign({}, step), { locator: base });
                    return [4, page.evaluate(function (step) {
                            var qawolf = window.qawolf;
                            return qawolf.rank.findTopElement(step, null);
                        }, stepWithLocator)];
                case 2:
                    highestMatch = _a.sent();
                    expect(highestMatch).toBeNull();
                    return [2];
            }
        });
    }); });
    test("returns null if a tie is found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, stepWithLocator, highestMatch;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "checkboxes")];
                case 1:
                    page = _a.sent();
                    stepWithLocator = __assign(__assign({}, step), { locator: __assign(__assign({}, base), { classList: null, id: null, inputType: "checkbox", textContent: null }), type: "type" });
                    return [4, page.evaluate(function (step) {
                            var qawolf = window.qawolf;
                            return qawolf.rank.findTopElement(step, null);
                        }, stepWithLocator)];
                case 2:
                    highestMatch = _a.sent();
                    expect(highestMatch).toBeNull();
                    return [2];
            }
        });
    }); });
    test("returns xpath of highest match if one found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var page, stepWithLocator, highestMatch;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 1:
                    page = _a.sent();
                    stepWithLocator = __assign(__assign({}, step), { locator: __assign(__assign({}, base), { classList: null, id: null, inputType: "password", labels: ["password"], textContent: null }), type: "type" });
                    return [4, page.evaluate(function (step) {
                            var qawolf = window.qawolf;
                            var element = qawolf.rank.findTopElement(step, null);
                            return qawolf.xpath.getXpath(element);
                        }, stepWithLocator)];
                case 2:
                    highestMatch = _a.sent();
                    expect(highestMatch).toBe("//*[@id='password']");
                    return [2];
            }
        });
    }); });
    describe("rank.waitForElement", function () {
        test("returns element based on data attribute if one provided", function () { return __awaiter(void 0, void 0, void 0, function () {
            var page, stepWithLocator, foundElement;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                    case 1:
                        page = _a.sent();
                        stepWithLocator = __assign(__assign({}, step), { locator: __assign(__assign({}, base), { classList: null, id: null, inputType: "password", labels: ["password"], textContent: null }), type: "type" });
                        return [4, page.evaluate(function (step) {
                                var qawolf = window.qawolf;
                                return qawolf.rank.waitForElement(step, null).then(function (element) {
                                    return qawolf.xpath.getXpath(element);
                                });
                            }, stepWithLocator)];
                    case 2:
                        foundElement = _a.sent();
                        expect(foundElement).toBe("//*[@id='password']");
                        return [2];
                }
            });
        }); });
        test("returns closest match element if no data attribute provided", function () { return __awaiter(void 0, void 0, void 0, function () {
            var page, stepWithLocator, foundElement;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                    case 1:
                        page = _a.sent();
                        stepWithLocator = __assign(__assign({}, step), { locator: __assign(__assign({}, base), { classList: null, dataValue: "password", id: null, inputType: "text", labels: null, textContent: null }), type: "type" });
                        return [4, page.evaluate(function (step) {
                                var qawolf = window.qawolf;
                                var password = document.getElementById("password");
                                password.setAttribute("data-qa", "password");
                                return qawolf.rank.waitForElement(step, "data-qa").then(function (element) {
                                    password.removeAttribute("data-qa");
                                    return qawolf.xpath.getXpath(element);
                                });
                            }, stepWithLocator)];
                    case 2:
                        foundElement = _a.sent();
                        expect(foundElement).toBe("//*[@id='password']");
                        return [2];
                }
            });
        }); });
        test("throws error if data attribute provided and no element found", function () { return __awaiter(void 0, void 0, void 0, function () {
            var page, stepWithLocator, throws;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                    case 1:
                        page = _a.sent();
                        stepWithLocator = __assign(__assign({}, step), { locator: __assign(__assign({}, base), { classList: null, dataValue: "password", id: null, inputType: "password", labels: ["password"], textContent: null }), type: "type" });
                        throws = function () { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2, page.evaluate(function (step) {
                                        var qawolf = window.qawolf;
                                        return qawolf.rank
                                            .waitForElement(step, "data-qa", 2000)
                                            .then(function (element) {
                                            return qawolf.xpath.getXpath(element);
                                        });
                                    }, stepWithLocator)];
                            });
                        }); };
                        return [4, expect(throws()).rejects.toThrowError()];
                    case 2:
                        _a.sent();
                        return [2];
                }
            });
        }); });
    });
});
//# sourceMappingURL=rank.test.js.map