"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var element_1 = require("./element");
var arrayEqual = function (array1, array2) {
    if (array1.length !== array2.length)
        return false;
    var intersection = array1.filter(function (item) { return array2.includes(item); });
    return intersection.length === array1.length;
};
exports.findByLabels = function (candidates, labels) {
    var matchingElement = null;
    for (var i = 0; i < candidates.length; i++) {
        var candidateLabels = element_1.getLabels(candidates[i]);
        if (!candidateLabels)
            continue;
        if (arrayEqual(labels, candidateLabels)) {
            matchingElement = candidates[i];
            break;
        }
    }
    return matchingElement;
};
exports.findByName = function (candidates, name) {
    var matchingElement = null;
    for (var i = 0; i < candidates.length; i++) {
        if (candidates[i].name === name) {
            matchingElement = candidates[i];
            break;
        }
    }
    return matchingElement;
};
exports.findByPlaceholder = function (candidates, placeholder) {
    var matchingElement = null;
    for (var i = 0; i < candidates.length; i++) {
        if (element_1.getPlaceholder(candidates[i]) === placeholder) {
            matchingElement = candidates[i];
            break;
        }
    }
    return matchingElement;
};
var isVisible = function (element) {
    var rect = element.getBoundingClientRect();
    return !!(rect.height && rect.width);
};
exports.queryVisible = function (selector) {
    var elements = document.querySelectorAll(selector);
    var visibleElements = [];
    for (var i = 0; i < elements.length; i++) {
        if (isVisible(elements[i])) {
            visibleElements.push(elements[i]);
        }
    }
    return visibleElements;
};
exports.sleep = function (milliseconds) {
    return new Promise(function (resolve) { return setTimeout(resolve, milliseconds); });
};
//# sourceMappingURL=utils.js.map